#include <iostream>

template <class T>
class Pilha { 

    public:
        void empilha(T elemento) {
            N++;
            elementos[N -1] = elemento;

        }
        T desempilha() {
            if (N > 0) {
                N--;
                return elementos[N];
            }
            else
                return -1;
        }

        T topo() {
            if (N > 0)
                return elementos[N -1];
            else   
                return -1;
        }
    private:
        static const int MAX = 900;
        int N = 0;
        T elementos[MAX];

};


/**
 * @brief 
 * Para fazer o algorítimo da Pilha Min
 * é necessário mantermos duas pilas, uma pilha onde armazenamos os elementos
 * e outra pilha onde armazenamos os elementos na ordem mínima.
 * 
 * Para fazermos isso, precisamos verificar a cada inserção na pilha se o elemento
 * que está sendo inserido é menor do que o que já está no topo da pilha mínima.
 * Se o elemento for menor, inserimos ele na pilha mínima
 * caso o elemento for maior, inserimos novamente o topo da pilha mínima nela mesma
 * 
 * dessa forma a quantidade de ítens ficam sincronizados, e mantemos sempre o último
 * elemento mínimo atualizado.
 * 
 * para assegurar que o elemento esteja sincronizado, quando removemos algum íten 
 * da pilha principal, devemos também remover o topo da pilha mínima. 
 * 
 * @tparam T 
 */
template <class T>
class PilhaMin { 

    public:
        void empilha(T elemento) {

            T min = elemento;
            if (pilhamin.topo() != -1 && min > pilhamin.topo())
                min = pilhamin.topo();
            pilha.empilha(elemento);
            pilhamin.empilha(min);

        }
        void desempilha() {
            pilha.desempilha();
            pilhamin.desempilha();
        }

        T topo() {
            return pilha.topo();
        }

        T obterMinimo() {
            return pilhamin.topo();
        }
    private:

        Pilha<T> pilha;
        Pilha<T> pilhamin;

};

void preencherPilha(PilhaMin<char> &pilha) {

    
    pilha.empilha('b');
    pilha.empilha('c');
    pilha.empilha('d');
    pilha.empilha('e');
    pilha.empilha('f');
    pilha.empilha('g');
    pilha.empilha('h');
    pilha.empilha('i');
    pilha.empilha('j');
    pilha.empilha('k');
    pilha.empilha('l');
    pilha.empilha('m');
    pilha.empilha('a');
    pilha.empilha('n');
    pilha.empilha('o');
    pilha.empilha('p');
    pilha.empilha('q');
    pilha.empilha('r');
    pilha.empilha('s');
    pilha.empilha('t');
    pilha.empilha('u');
    pilha.empilha('v');
    pilha.empilha('w');
    pilha.empilha('x');
    pilha.empilha('1');
    pilha.empilha('y');
    pilha.empilha('z');
}


int main(int argc, char* argv[]) {


    PilhaMin<char> pilha;

    preencherPilha(pilha);

    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;
    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;
    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;
    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;
    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;


    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    std::cout << "Desempilhando o : "<< pilha.topo() <<  std::endl;
    pilha.desempilha();
    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;






    return 0;
}